#include "Ogre.h" 
#include "OgreFrameListener.h" 
#include "OgreEventListeners.h" 
#include "OgreKeyEvent.h"

#include "OgreSceneNode.h"
#include "chadplayer.h"
#include "chadenemy.h"
#include <vector>
#include <algorithm>

#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>


using namespace Ogre;

bool IsNull(void* somepointer) { return (somepointer == NULL); }

class CChadGame : public FrameListener, public MouseListener, public MouseMotionListener, public KeyListener {
public:
	CChadGame();
	~CChadGame();
	bool loadConfig();
	void initialise();
	int run();

	void createOutdoorScene();
	void createIndoorScene();

	// this function was getting a bit big, so I've moved it into chad.cpp
	bool frameStarted(const FrameEvent& evt);
	bool frameStartedOutside(const FrameEvent& evt);
	bool frameStartedInside(const FrameEvent& evt);

	bool frameEnded(const FrameEvent& evt) { 
		return true; 
	}

	void mouseClicked(MouseEvent* e) { }
	void mouseEntered(MouseEvent* e) { }
	void mouseExited(MouseEvent* e)  { }

	void mousePressed(MouseEvent* e);

	void mouseReleased(MouseEvent* e) { }
	
	void mouseMoved(MouseEvent *e) {
		m_CameraNode->yaw( Radian(-e->getRelX() * 1.0), Node::TS_WORLD);
		m_CameraNode->pitch( Radian(-e->getRelY() * 1.0) );
	}

	void mouseDragged(MouseEvent *e) {
		m_CameraNode->yaw( Radian(-e->getRelX() * 1.0),  Node::TS_WORLD );
		m_CameraNode->pitch( Radian(-e->getRelY() * 1.0) );
	}

	void keyPressed(KeyEvent *e);
	void keyReleased(KeyEvent *e);
	void keyClicked(KeyEvent *e) { }

	Root* m_Ogre;
	EventProcessor* m_EventProcessor;
	InputReader* m_InputReader;

	SceneManager* m_SceneMgr;
	Camera* m_Camera;
	SceneNode* m_CameraNode;
	Viewport* m_Viewport;

	CChadPlayer* m_Player;

	SceneNode* OceanNode;
	double m_OceanFlowNum;

	Entity* HouseEntity;
	Light* m_SunLight;
	Light* m_MoonLight;

	double m_SunY;
	double m_SunZ;

	int scenemanager;

	Mix_Chunk* m_MixFire;
	Mix_Music* m_Music;

	std::vector<CChadEnemy*> Enemies;
};
